import java.util.*;

public class Archivio 
{
  ArrayList<Automobile> archivio = new ArrayList<Automobile>(); 

public void insert(String targa, Cliente cliente) {
	insert(new Automobile (targa, cliente));
}

public void insert(Automobile auto2) {
	for (Automobile auto: archivio) {
		if (auto.equals(auto2)) {
			auto.setCliente(auto2.getCliente());
			return;
		}
	}
	archivio.add(auto2);
}


public boolean delete (String targa) {
	return archivio.remove(new Automobile(targa));
}


public Archivio crea_byCitta(String citta) {
	Archivio nuovo  = new Archivio();
	for (Automobile a: archivio)
		if ( (a.getCliente().getCitta()).equals(citta.toUpperCase()) ) nuovo.insert(a);
	return nuovo;
}
  
 
public void sort_byTarga() {
	Collections.sort(archivio);
}

public void sort_byCF() {
	Collections.sort(archivio, new Cmp_byCF());
}

   /**
   * Restituisce una rappresentazione String di questo archivio   */
  public String toString()
  {   String s = new String("\n");
	  for (Automobile a: archivio) {
		  s += a.toString() + ";\n";
	  }
	  return s;
  } // method toString
  
} // end-class 


class Cmp_byCF implements Comparator<Automobile>{
  public int compare(Automobile a1, Automobile a2) {
	  return (a1.getCliente()).compareTo((a2.getCliente()));
  }
}

